#!/usr/bin/perl
do '../web-lib.pl';
&init_config();
&ReadParse();
#use Filesys::Statvfs (statvfs);
use Filesys::Df;

&header("Disk Usage", "", undef, 1, 1);

$img = "<img src=\"block.cgi";
chdir($homedir=$config{'directory'});
$rootref = df("/");

open(FSTAB, "/etc/fstab") || open(FSTAB, "/etc/vfstab");
while(<FSTAB>){
    next if /^#/;
    if (/^(\S+)\s+(\S+)/ && $2 eq $homedir) {
	$homeref = df($homedir);
	$drivek = $homeref->{blocks};
	$free{'kb'} = $homeref->{bfree};
	last; }
}
close(FSTAB);
$drivek += $rootref->{blocks};
$free{'kb'} += $rootref->{bavail};

opendir(CWD, $homedir);
@files = sort {$a cmp $b} readdir(CWD);
closedir(CWD);
shift(@files); shift(@files);

use integer;
$blockk = $drivek / 400;
for($i=0;$i<=$#files;$i++){
	next unless -d $files[$i];
	$sizek = (split(' ', `du -sk $files[$i]`))[0];

	$info{$files[$i]}->{'kb'} = $sizek;
	$info{$files[$i]}->{'bl'} = $sizek/$blockk;
	if( $in{'trash'} && -d "$files[$i]/.trash/files/" ){
	    $info{$files[$i]}->{'tr'} = (split(' ', `du -sk $files[$i]/.trash`))[0];
	    $info{$files[$i]}->{'lm'} = scalar localtime((stat("$files[$i]/.trash/files"))[9]);
	}
	else{
	    $info{$files[$i]}->{'tr'} = 'NA';
	    $info{$files[$i]}->{'lm'} = 'Not Applicable';
	}
	
	$homesize += $sizek }

$sys{'kb'}  = $drivek - $free{'kb'} - $homesize;
$sys{'bl'}  = 400 * $sys{'kb'} /$drivek;
if( $in{'trash'} ){
    $sys{'tr'} = (split(/\s+/, `du -sk /var/trash`))[0];
    $sys{'lm'} = scalar localtime( (stat("/var/trash/files"))[8] );
    $sys{'lm'} =~ s/ /&nbsp;/g; }

$free{'bl'} = 400 - $sys{'bl'};

for($i=0; $i<=$#dirs; $i++){
}
no integer;

print "<hr><center><h3>Disk usage for $homedir</h3>\n";
print "<table cellpadding=0 cellspacing=8 align=center><tr><td width=400>";

print qq($img?r=255&g=255&b=255" alt=System>) x $sys{'bl'};


$legend = qq(<tr $tb><th><a href="?trash=).($in{'trash'} ? '0"><img src="images/0.gif" border=0>' : '1"><img src="images/1.gif" border=0>')."</a></td><td>Where</td><td>Blocks</td><td>KiloBytes</td>";
if( $in{'trash'} ){
    $legend .= "<td>Trashcan</td><td>Last Accessed</td>"; }

$legend .= "</tr>\n";
$legend .= qq(<tr><td>$img?r=255&g=255&b=255"></td><td>System</td><td align=right><tt>$sys{'bl'}</tt></td><td align=right><tt>$sys{'kb'}</tt></td>);
if( $in{'trash'} ){
    $legend .= "<td align=right><tt>$sys{'tr'}</tt></td><td>$sys{'lm'}</td>"; }
$legend .= "</tr>\n";

$divisions = (scalar keys %info) +1;
foreach $k ( sort {$a cmp $b } keys %info ){
    next if $k eq "root";
    $out = "$img?" . doColor($i) . qq(" alt="$k">);
	$legend .= "<tr><td>$out</td><td>$k</td><td align=right><tt>$info{$k}->{'bl'}</tt></td><td align=right><tt>$info{$k}->{'kb'}</tt></td>";
	if( $in{'trash'} ){
        $legend .= "<td align=right><tt>$info{$k}->{'tr'}</tt></td><td>$info{$k}->{'lm'}</td>"; }

$legend .= "</tr>\n";
        $i++;
	print $out x $info{$k}->{'bl'};
	$free{'bl'}-=$info{$k}->{'bl'};
}

print qq($img?r=192&g=192&b=192" alt=Free>) x $free{'bl'};

$legend .= qq(<tr><td>$img?r=192&g=192&b=192"></td><td>Free</td><td align=right><tt>$free{'bl'}</tt></td><td align=right><tt>$free{'kb'}</tt></td></tr>\n);
$legend .= qq(<tr><td>$img?r=000&g=000&b=000"></td><td>Total</td><td align=right><tt>400</tt></td><td align=right><tt>$drivek</tt></td></tr>\n);

print "\n</td><td valign=top><table $cb border>$legend<caption align=bottom>One block = $blockk kb</caption></table></td>";
print "</tr></table></center>\n";

print "<center>Developed by <a href='http://www.pthbb.org/'>Jerrad Pierce</a> for <a href='http://www.networkengines.com/'>NEI</a></center>\n";

print "<hr>\n";
&footer("/", $text{'index'});

sub doColor {
    my $t = shift();
    my $fract = $t/$divisions;
    $R = int($t/2) == $t/2 ? 255 : 0;
    $G = (int(255*$fract));
    $B = (int(255*(1-$fract)));
    return "r=$R&g=$G&b=$B";
}
